package cz.muni.fi.pa165.addressbook;

import java.io.Serializable;
import java.util.AbstractMap;
import java.util.AbstractSet;
import java.util.Collection;
import java.util.Map;
import java.util.Set;
import org.hibernate.Session;
import org.hibernate.SessionFactory;
import org.hibernate.Transaction;
import org.hibernate.cfg.Configuration;

/**
 *
 * @author petr
 */
public class AddressBook implements Serializable {
    
    private transient SessionFactory sessionFactory;
    
    private void initSessionFactory() {
	ExampleData.createExampleData();
	sessionFactory = new Configuration().configure().buildSessionFactory();
    }
    
    public AddressBook() {
	try {
	    initSessionFactory();
	} catch (RuntimeException ex) {
	    ex.printStackTrace();
	    throw ex;
	}
    }
    
    public Collection getPeople() {
	Session session = null;
	try {
	    session = sessionFactory.openSession();
	    Collection result = session.createQuery("select c from Person as c").list();
	    return result;
//	} catch (RuntimeException ex) {
//	    ex.printStackTrace();
//	    throw ex;
	} finally {
	    if (session != null) {
		session.close();
	    }
	}
    }
    
    public Person getPerson(Integer id) {
	Session session = null;
	try {
	    session = sessionFactory.openSession();
	    return (Person) session.get(Person.class,id);
//	} catch (RuntimeException ex) {
//	    ex.printStackTrace();
//	    throw ex;
	} finally {
	    if (session != null) {
		session.close();
	    }
	}
    }
    
    public void updatePerson(Integer id, String name, String address) {
	Session session = null;
	Transaction tx = null;
	try {
	    session = sessionFactory.openSession();
	    tx = session.beginTransaction();
	    Person person = (Person) session.get(Person.class, id);
	    person.setName(name);
	    person.setAddress(address);
	    session.update(person);
	    tx.commit();
	} catch (RuntimeException ex) {
//	    ex.printStackTrace();
	    if (tx != null) {
		tx.rollback();
	    }
	    throw ex;
	} finally {
	    if (session != null) {
		session.close();
	    }
	}
    }

    public void newPerson(String name, String address) {
	Session session = null;
	Transaction tx = null;
	try {
	    session = sessionFactory.openSession();
	    tx = session.beginTransaction();
	    Person person = new Person();
	    person.setName(name);
	    person.setAddress(address);
	    session.save(person);
	    tx.commit();
	} catch (RuntimeException ex) {
//	    ex.printStackTrace();
	    if (tx != null) {
		tx.rollback();
	    }
	    throw ex;
	} finally {
	    if (session != null && !session.isOpen()) {
		session.close();
	    }
	}
    }
    
    public PhoneNumber addPhoneNumber(Person person, String number,
    String description) {
	return null;
    }
    
}
